"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const async_component_1 = require("./async-component");
const util_1 = require("./util");
const { appendScript, appendLink, requireDefault } = util_1.default;
/**
 * 提供 code split & lazy load & spa
 *
 * @author gcy[of1518]
 */
class PageView extends React.Component {
    constructor(props) {
        super(props);
        /**
         * load
         */
        this.load = () => __awaiter(this, void 0, void 0, function* () {
            return yield new Promise((resolve, reject) => {
                try {
                    const { name } = this.props;
                    if (typeof __QM_GLOBAL_PAGEVIEW != "undefined" && __QM_GLOBAL_PAGEVIEW[name]) {
                        let mod = __QM_GLOBAL_PAGEVIEW[name];
                        mod = requireDefault(mod);
                        resolve(mod);
                    }
                    else {
                        let pageview = typeof $CONST_PAGEVIEW != "undefined" ? $CONST_PAGEVIEW : "{}";
                        pageview = JSON.parse(pageview);
                        let [path, ...source] = pageview[name];
                        (source || []).forEach(s => {
                            s.includes(".css")
                                ? appendLink({ name: `${name}_css`, href: `${path}/${s}` })
                                : appendScript({
                                    src: `${path}/${s}`,
                                    name: `${name}_js`,
                                    onload: () => {
                                        let mod = __QM_GLOBAL_PAGEVIEW[name];
                                        mod = requireDefault(mod);
                                        resolve(mod);
                                    },
                                    onerror: () => reject(requireDefault(null)),
                                });
                        });
                    }
                }
                catch (e) {
                    console.error(e);
                }
            });
        });
    }
    render() {
        return React.createElement(async_component_1.default, Object.assign({}, this.props, { render: this.load }));
    }
}
PageView.defaultProps = {
    name: "",
};
exports.default = PageView;
